/*
 * Copyright (C) 2004  Heinz Mauelshagen, Red Hat GmbH. All rights reserved.
 *
 * This dmraid code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * dmraid is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this dmraid library; if not, write to the Free
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA
 */

#ifndef _LIB_CONTEXT_H_
#define _LIB_CONTEXT_H_

#include "datastruct/list.h"
#include "misc/misc.h"

struct lib_context {
	char *cmd;

	/* Lists for metadata format handlers the library supports. */
	struct list_head formats;

	/* Lists for block + raid devices and raid sets. */
	struct list_head disk_infos;
	struct list_head raid_devices;
	struct list_head raid_sets;

	struct lib_version version;

	struct {
		unsigned char column;
		unsigned char debug;
		unsigned char dump;
		unsigned char group;
		unsigned char test;
		unsigned char verbose;
	} opts;
};

struct lib_context *alloc_lib_context(char **argv);
void free_lib_context(struct lib_context *lc);

#endif
