/*
 * Copyright (C) 2004  Heinz Mauelshagen, Red Hat GmbH. All rights reserved.
 *
 * This dmraid code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * dmraid is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this dmraid library; if not, write to the Free
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA
 */

#ifndef _MISC_H_
#define _MISC_H_

struct lib_version {
	const char *text;
	struct {
		unsigned int major;
		unsigned int minor;
		unsigned int sub_minor;
		const char *suffix;
	} v;
};

void sysfs_workaround(void);
void mk_alpha(char *str, size_t len);

struct lib_context;
int libdmraid_init(struct lib_context **lc, int argc, char **argv);
void libdmraid_exit(struct lib_context *lc);
const char *libdmraid_version(struct lib_context *lc);

int yes_no_prompt(const char *prompt, ...);

int grow_string(char **string, size_t len);
void free_string(char **string);
int p_str(char **string, const char *s);
int p_u64(char **string, uint64_t u);

#endif
