/*
 * Copyright (C) 2004  Heinz Mauelshagen, Red Hat GmbH. All rights reserved.
 *
 * This dmraid code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * dmraid is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this dmraid code; if not, write to the Free
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA
 */

/*
 * See commands.[ch] for the function call abstraction below called perform().
 */

#include <dmraid.h>
#include "commands.h"
#include "toollib.h"
#include "version.h"

int main(int argc, char **argv)
{
	int ret;
	struct lib_context *lc;

	/* Initialize library and create a context to use it. */
	if (!libdmraid_init(&lc, argc, argv))
		return 1;

	/*
	 * Parse command line arguments and run 'early' functions
	 * for options which set library context variables (eg, --debug).
	 */
	if (!handle_args(lc, argc, &argv))
		return 1;

	/*
	 * Perform actions for options.
	 */
	ret = perform(lc, argv);

	/* Clean up before exit... */
	free_format_names();
	libdmraid_exit(lc);

	return (ret ? 0 : 1);
}
